/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.shopping.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for ShoppingModelExtrasJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelExtrasJsonV1 extends GenericJson {

  /**
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<FacetRules> facetRules;

  static {
    // hack to force ProGuard to consider FacetRules used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(FacetRules.class);
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RankingRules> rankingRules;

  static {
    // hack to force ProGuard to consider RankingRules used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(RankingRules.class);
  }

  /**

   * The value returned may be {@code null}.
   */
  public java.util.List<FacetRules> getFacetRules() {
    return facetRules;
  }

  /**

   * The value set may be {@code null}.
   */
  public ShoppingModelExtrasJsonV1 setFacetRules(java.util.List<FacetRules> facetRules) {
    this.facetRules = facetRules;
    return this;
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * The value returned may be {@code null}.
   */
  public java.util.List<RankingRules> getRankingRules() {
    return rankingRules;
  }

  /**
   * Names of boost (ranking) rules applicable to this search.
   * The value set may be {@code null}.
   */
  public ShoppingModelExtrasJsonV1 setRankingRules(java.util.List<RankingRules> rankingRules) {
    this.rankingRules = rankingRules;
    return this;
  }

  /**
   * Model definition for ShoppingModelExtrasJsonV1FacetRules.
   */
  public static final class FacetRules extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String name;

    /**

     * The value returned may be {@code null}.
     */
    public String getName() {
      return name;
    }

    /**

     * The value set may be {@code null}.
     */
    public FacetRules setName(String name) {
      this.name = name;
      return this;
    }

  }

  /**
   * Model definition for ShoppingModelExtrasJsonV1RankingRules.
   */
  public static final class RankingRules extends GenericJson {

    /**
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private String name;

    /**

     * The value returned may be {@code null}.
     */
    public String getName() {
      return name;
    }

    /**

     * The value set may be {@code null}.
     */
    public RankingRules setName(String name) {
      this.name = name;
      return this;
    }

  }

}
