/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.shopping.model;

import com.google.api.client.json.GenericJson;

/**
 * Model definition for ShoppingModelRecommendationsJsonV1.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Search API For Shopping. For a detailed explanation
 * see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class ShoppingModelRecommendationsJsonV1 extends GenericJson {

  /**
   * List of recommendations.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<RecommendationList> recommendationList;

  static {
    // hack to force ProGuard to consider RecommendationList used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(RecommendationList.class);
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String type;

  /**
   * List of recommendations.
   * The value returned may be {@code null}.
   */
  public java.util.List<RecommendationList> getRecommendationList() {
    return recommendationList;
  }

  /**
   * List of recommendations.
   * The value set may be {@code null}.
   */
  public ShoppingModelRecommendationsJsonV1 setRecommendationList(java.util.List<RecommendationList> recommendationList) {
    this.recommendationList = recommendationList;
    return this;
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * The value returned may be {@code null}.
   */
  public String getType() {
    return type;
  }

  /**
   * Type of recommendation list (for offer-based recommendations, one of: all, purchaseToPurchase,
   * visitToVisit, visitToPurchase, relatedItems; for category-based recommendations, one of: all,
   * categoryMostVisited, categoryBestSeller).
   * The value set may be {@code null}.
   */
  public ShoppingModelRecommendationsJsonV1 setType(String type) {
    this.type = type;
    return this;
  }

  /**
   * Model definition for ShoppingModelRecommendationsJsonV1RecommendationList.
   */
  public static final class RecommendationList extends GenericJson {

    /**
     * Recommended product.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private ShoppingModelProductJsonV1 product;

    /**
     * Recommended product.
     * The value returned may be {@code null}.
     */
    public ShoppingModelProductJsonV1 getProduct() {
      return product;
    }

    /**
     * Recommended product.
     * The value set may be {@code null}.
     */
    public RecommendationList setProduct(ShoppingModelProductJsonV1 product) {
      this.product = product;
      return this;
    }

  }

}
